public class Problema {

	public No[] nos;
	public Cavalo[] cavalos;

	public Problema() {

		this.nos = new No[9];
		this.cavalos = new Cavalo[4];

	}

	public void montarProblema() {

		for (int i = 0; i < nos.length; i++) {
			nos[i] = new No(i);
		}

		nos[0].nextAntiHorario = nos[5];
		nos[0].nextHorario = nos[7];
		nos[0].estaOcupado = true;
	

		nos[1].nextAntiHorario = nos[8];
		nos[1].nextHorario = nos[6];

		nos[2].nextAntiHorario = nos[7];
		nos[2].nextHorario = nos[3];
		nos[2].estaOcupado = true;
		
		nos[3].nextAntiHorario = nos[2];
		nos[3].nextHorario = nos[8];

		nos[5].nextAntiHorario = nos[6];
		nos[5].nextHorario = nos[0];

		nos[6].nextAntiHorario = nos[1];
		nos[6].nextHorario = nos[5];
		nos[6].estaOcupado = true;
		nos[6].corCavalo = true;
		
		nos[7].nextAntiHorario = nos[0];
		nos[7].nextHorario = nos[2];

		nos[8].nextAntiHorario = nos[3];
		nos[8].nextHorario = nos[1];
		nos[8].estaOcupado = true;
		nos[8].corCavalo = true;
		
		cavalos[0] = new Cavalo(false, nos[0]);
		cavalos[1] = new Cavalo(false, nos[2]);
		cavalos[2] = new Cavalo(true, nos[8]);
		cavalos[3] = new Cavalo(true, nos[6]);
	}

	public void resolverProblema() {
		
		
		boolean resolveu = (nos[6].estaOcupado && !nos[6].corCavalo)
		&& (nos[8].estaOcupado && !nos[8].corCavalo)
		&& (nos[0].estaOcupado && nos[0].corCavalo)
		&& (nos[2].estaOcupado && nos[2].corCavalo);

		int cont = 0;
		
		while (!resolveu) {

			for(int i = 0; i < 4; i++){
				cont++;
				this.cavalos[i].andarAntiHorario();
				System.out.println("CAVALO " + i +" : ");
				System.out.println(this.cavalos[i].noAtual.numero);


			}

			System.out.println("----------------------------------------");
				
			
			resolveu = (nos[6].estaOcupado && !nos[6].corCavalo)
			&& (nos[8].estaOcupado && !nos[8].corCavalo)
			&& (nos[0].estaOcupado && nos[0].corCavalo)
			&& (nos[2].estaOcupado && nos[2].corCavalo);


		}
		System.out.println("resolveu danadao!!! com " + cont + " mexidas de cavalo");
		
	}

	public static void main(String[] args) {

		Problema problema = new Problema();
		problema.montarProblema();
		problema.resolverProblema();
		

	}

}
